/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_GETOPT
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_getopt.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <unistd.h>
#include <stdlib.h>
#include <getopt.h>

static size_t optarg_loc
#line 21 "bi_getopt.m4"
;
static size_t optind_loc
#line 22 "bi_getopt.m4"
;
static size_t opterr_loc
#line 23 "bi_getopt.m4"
;
static size_t optopt_loc
#line 24 "bi_getopt.m4"
;

void
#line 26
bi_getopt(eval_environ_t env)
#line 26

#line 26 "bi_getopt.m4"
{
#line 26
	
#line 26

#line 26
long __bi_argcnt;
#line 26
long  argc;
#line 26
        long  argoff;
#line 26
        
#line 26
get_numeric_arg(env, 1, &argc);
#line 26
        get_numeric_arg(env, 2, &argoff);
#line 26
        
#line 26
get_numeric_arg(env, 0, &__bi_argcnt);
#line 26
        adjust_stack(env, __bi_argcnt + 1);
#line 26

#line 26
	if (prog_trace_option & BUILTIN_MASK_getopt)
#line 26
		prog_trace(env, "getopt %lu %lu",argc, argoff);;
#line 26

{
	int rc;
	int long_idx;
	char s[2] = { 0, 0 };
	static char xargc;
	static char **xargv;
	static struct option *option;
	static char *optstr;
	static char *loptstr;
	
	if (argc) {
		size_t i, n;
		size_t serial = 256;
		
		xargc = argc + 1;
		xargv = xcalloc(xargc+1, sizeof(xargv[0]));
		xargv[0] = script_file;
		for (i = 0; i < argc; i++)
			xargv[i+1] = env_vaptr(env, argoff + i);
		xargv[i+1] = NULL;

		n = (__bi_argcnt - 2);
		if (n) {
			size_t i, j;
			size_t len;
			char *str;
			size_t size, lsize, lcnt;
			
			
#line 55
unroll_stack(env, __bi_argcnt + 1);

			size = lsize = lcnt = 0;
			for (i = 0; i < n; i++) {
				
#line 59
 ((__bi_argcnt > i+2) ?   get_string_arg(env, i+2 + 1, &str) :   (	env_throw_bi(env, mfe_range, "getopt", "Argument %d is not supplied",i+2),(char *) 0));
				len = strcspn(str, "|");
				size += len;
				str += len;
				if (*str) {
					lcnt++;
					lsize += strlen(str);
				}
			}

			optstr = xrealloc(optstr, size + 1);
			loptstr = xrealloc(loptstr, lsize + 1);
			option = xrealloc(option,
					  (lcnt + 1) * sizeof(option[0]));
			
			size = 0;
			lsize = 0;
			for (i = j = 0; i < n; i++) {
				size_t len;
				int val;
				char *flags;
					
				
#line 81
 ((__bi_argcnt > i+2) ?   get_string_arg(env, i+2 + 1, &str) :   (	env_throw_bi(env, mfe_range, "getopt", "Argument %d is not supplied",i+2),(char *) 0));
				len = strcspn(str, "|");

				if (len > 0) {
					flags = str + 1;
					if (i == 0 || str[0] != '-') {
						memcpy(optstr + size, str,
						       len);
						size += len;
						val = str[0];
					} else
						val = serial++;
				} else {
					flags = "";
					val = serial++;
				}

				str += len;
				
				if (*str) {
					option[j].name = loptstr + lsize;
					strcpy(loptstr + lsize, str + 1);
					lsize += strlen(str) + 1;
					if (flags[0] == ':') 
						option[j].has_arg =
							(flags[1] == ':') ?
							  optional_argument :
							  required_argument;
					else
						option[j].has_arg =
							no_argument;
					option[j].flag = NULL;
					option[j].val = val;
					j++;
				}
			}
			adjust_stack(env, __bi_argcnt + 1);
			optstr[size] = 0;
			loptstr[lsize] = 0;
			memset(&option[j], 0, sizeof option[0]);
		} else
			option = NULL;
	}

	if (xargc == 0 || optstr == NULL || option == 0)
		do {pushs(env, "");
#line 126
return;
#line 126
} while (0);
	
	optind = (int) *env_data_ref(env, optind_loc) ;
	opterr = (int) *env_data_ref(env, opterr_loc) ;
	
	rc = getopt_long(xargc, xargv, optstr, option, &long_idx);
	*env_data_ref(env, optind_loc) = (STKVAL) (optind);
	*env_data_ref(env, opterr_loc) = (STKVAL) (opterr);
	s[0] = optopt;
	
#line 135
{ size_t off;
#line 135
  const char *s = s;
#line 135
  if (s)
#line 135
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(s) + 1)), s);
#line 135
  else
#line 135
     off = 0;
#line 135
  *env_data_ref(env, optopt_loc) = (STKVAL) (off); }
#line 135
;
	
#line 136
{ size_t off;
#line 136
  const char *s = optarg;
#line 136
  if (s)
#line 136
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(s) + 1)), s);
#line 136
  else
#line 136
     off = 0;
#line 136
  *env_data_ref(env, optarg_loc) = (STKVAL) (off); }
#line 136
;
	if (rc == EOF)
		do {pushs(env, "");
#line 138
return;
#line 138
} while (0);
	if (rc < 256) {
		s[0] = rc;
		do {pushs(env, s);
#line 141
return;
#line 141
} while (0);
	}
	do {pushs(env, option[long_idx].name);
#line 143
return;
#line 143
} while (0);
}
}


#line 147
void
#line 147
getopt_init_builtin()
#line 147
{
#line 147
	#line 21 "bi_getopt.m4"
	builtin_variable_install("optarg", dtype_string, SYM_VOLATILE, &optarg_loc);
#line 22 "bi_getopt.m4"
	builtin_variable_install("optind", dtype_number, SYM_VOLATILE, &optind_loc);
#line 23 "bi_getopt.m4"
	builtin_variable_install("opterr", dtype_number, SYM_VOLATILE, &opterr_loc);
#line 24 "bi_getopt.m4"
	builtin_variable_install("optopt", dtype_string, SYM_VOLATILE, &optopt_loc);
#line 26 "bi_getopt.m4"
va_builtin_install_ex("getopt", bi_getopt, 0, dtype_string, 2, 0, 0|MFD_BUILTIN_VARIADIC, dtype_number, dtype_number);

#line 147 "bi_getopt.m4"
	struct value val;
#line 147
	val.type = dtype_number;
#line 147
	val.v.number = 1;
#line 147
	ensure_initialized_variable("opterr", &val);
#line 147
	
#line 147
}
#line 152

#line 627 "../mfd/snarf.m4"

#line 627

